unit Beastwin;

interface

uses
  SysUtils, WinTypes, WinProcs, Graphics, Forms,
  Classes, StdCtrls, Buttons, ExtCtrls, Controls, QDB;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    {these are the replacements for their DB counterparts}
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Image1: TImage;
    {these replace the DB controls and datasources}
    QDB1: TQDB;
    QDBNavigator1: TQDBNavigator;
    {we add a help button to explain}
    SpeedButton1: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure QDB1Navigate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    procedure LoadBitmap(Item: PChar; ItemLen: word; Bitmap: TBitMap);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{the data we will store is of the following format}
type
  Data = record
    Name: string[10];
    Size: string[2];
    Wght: string[2];
    Area: string[20];
    Bmp : array [0..40000] of byte; {big enough for these particular bitmaps}
  end;

procedure TForm1.FormCreate(Sender: TObject);
begin
{at the start we open the database at the beginning}
QDB1.FileName:='qdbdemo2.qdb';
QDB1.FirstItem;
end;

{every time we move through the database we do this ...}
procedure TForm1.QDB1Navigate(Sender: TObject);
var
  Item   : ^ Data;
  ItemLen: word;
begin
{make room for the data item}
GetMem(Item,SizeOf(Data));
{get it fromthe current place in the database}
QDB1.GetItem(Item);
{set the textual data}
with Item^ do
  begin
  Edit1.Text:=Name;
  Edit2.Text:=Size;
  Edit3.Text:=Wght;
  Edit4.Text:=Area;
  end;
{work out how big the bitmap is}
ItemLen:=SizeOf(Data) - SizeOf(Item^.Bmp) + QDB1.ItemSize;
{and load it into the Image control}
LoadBitMap(@(Item^.Bmp), ItemLen, Image1.Picture.BitMap);
{finally tidy up the memory}
FreeMem(Item,SizeOf(Data));
end;

procedure TForm1.LoadBitmap(Item: PChar; ItemLen: word; Bitmap: TBitMap);
var
  TempFileNameBuffer: PChar;
  TempFileName      : string;
  TempFile          : Integer;
begin
{get a temp filename}
TempFileNameBuffer:=StrAlloc(150);
try
  GetTempFileName(GetTempDrive('C'),'QDB',0,TempFileNameBuffer);
  TempFileName:=ChangeFileExt(StrPas(TempFileNameBuffer),'.bmp');
finally
  StrDispose(TempFileNameBuffer);
end;
{open up the temp file & write the item to the file in one go}
TempFile:=FileCreate(TempFileName);
FileWrite(TempFile,Item^,ItemLen);
{close the file}
FileClose(TempFile);
{load bitmap from the temp file}
BitMap.LoadFromFile(TempFileName);
{delete the temporary file}
DeleteFile(TempFileName);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
Application.HelpCommand(HELP_CONTENTS,0);
end;

end.
