unit Name2key;

interface

function NameToKey(Name: string): string;

implementation

function PosCAfter(C: Char; var Str; n: Integer): Integer;
begin
inline(
  $C4/$BE/>Str/
  $C7/$46/$FE/$00/$00/

  $8A/$86/>C/
  $31/$C9/
  $8A/$0D/
  $E3/$19/
  $89/$CB/
  $2B/$8E/>n/
  $7E/$11/
  $03/$BE/>n/
  $47/
  $FC/
  $F2/$AE/
  $75/$07/
  $F7/$D9/
  $01/$D9/
  $89/$4E/$FE
 );
end;

procedure StripL (var Str; C: Char);
begin
inline(
  $1E/
  $C4/$BE/>Str/
  $8C/$C0/
  $8E/$D8/
  $89/$FB/
  $8A/$86/>C/
  $29/$C9/
  $8A/$0D/
  $E3/$17/
  $47/
  $3A/$05/
  $75/$12/
  $47/
  $49/
  $FC/
  $F3/$AE/
  $74/$07/
  $89/$FE/
  $89/$DF/
  $47/
  $4E/
  $41/
  $89/$0F/
  $F2/$A4/
  $1F
 );
end;

procedure StripR (var Str; C: Char);
begin
inline(
  $1E/
  $C4/$BE/>Str/
  $8C/$C0/
  $8E/$D8/
  $89/$FB/
  $8A/$86/>C/
  $29/$C9/
  $8A/$0D/
  $E3/$0E/
  $01/$CF/
  $3A/$05/
  $75/$08/
  $FD/
  $F3/$AE/
  $74/$01/
  $41/
  $88/$0F/
  $1F);
end;

function NameToKey(Name: string): string;
var
  NewName     : string;
  CommaPos    : Byte;
  SpacePos    : Byte;
  LastSpacePos: Byte;
begin
NewName:=Name;
StripL(NewName,' ');
{ then remove anything after a comma, e.g. strip off the S.J.'s}
CommaPos:= PosCAfter(',',NewName,0);
if CommaPos <> 0 then
  NewName:= Copy(NewName,1,CommaPos - 1);
{ now strip off trailing spaces and see if anything is left }
StripR(NewName,' ');
if Length(NewName) = 0 then
  begin
  Result:='';
  Exit;
  end;
{ finally, find the last space in the name and take it to delimit the surname }
LastSpacePos:= 1;
SpacePos:= 1;
while SpacePos <> 0 do
  begin
  LastSpacePos:= SpacePos;
  SpacePos:= PosCAfter(' ',NewName,SpacePos);
  end;
{ then just invert the order }
if LastSpacePos = 1 then
  Result:=NewName
else
  Result:=Copy(NewName,LastSpacePos + 1,high(integer)) + ', ' + Copy(NewName,1,LastSpacePos - 1);
end;


end.
 